<?php
/*
============================================================
    AdvancedSearch for CMSimple
============================================================
    Version:    available in file plugins/advanced_search/index.php 
    Copyright:  © Jerry Jakobsfeld
    Website:    http://cmsimpleplugins.jakobsfeld.dk
    This file is a part of advanced_search plugin and repalce the original CMSimple file search.php by Peter Harteg.
*/
if (eregi('search.php', sv('PHP_SELF')))die('Access Denied');

global $hjs, $sl;

if (trim($plugin_tx['advanced_search']['helpshort'])!="") { 
	$plugin_tx['advanced_search']['helpshort']= tag('br').'<fieldset><legend>'.$plugin_tx['advanced_search']['helplegend'].'</legend>'.$plugin_tx['advanced_search']['helpshort'].'&nbsp;'.tag('img src="'.$pth['folder']['base'].$plugin_cf['advanced_search']['help_icon'].'" valign="bottom" width="14 "hight="14"').'</fieldset>';
}
$plugin_tx['advanced_search']['helplong']=tag('br').'<fieldset><legend>'.$plugin_tx['advanced_search']['helplegend'].'</legend>'.$plugin_tx['advanced_search']['helplong'].'</fieldset>';

$hjs.= '
<script type="text/javascript">
/* <![CDATA[ */ 
	function getRefToDiv(divID) {
		if( document.getElementById ) {
			return document.getElementById(divID); }
		if( document.all ) {
			return document.all[divID]; }
		
		return false;
	}

	function showtxt(divID,content) {
		myReference = getRefToDiv(divID);
		if( typeof( myReference.innerHTML ) != "undefined" ) {
			//used by all current browsers
			myReference.innerHTML = content=="short"?helps:helpl;
		}
		else 
		if ( myReference.document && myReference.document != window.document ) {
			//used by layers browsers
			myReference.document.open();
			myReference.document.write(content);
			myReference.document.close();
		} 
	}
	helps=\''.preg_replace("/\//","\/",$plugin_tx['advanced_search']['helpshort']).'\';
	helpl="'.preg_replace("/\//","\/",addslashes($plugin_tx['advanced_search']['helplong'])).'";
	/* ]]> */ 
</script>';
if (eregi("true",$plugin_cf['advanced_search']['hide_searchbox']))
  $hjs.='<style type="text/css">#searchbox{display:none;}</style>';

$title = $plugin_tx['advanced_search']['search'];
$hits = array();
$likes = array();
$plugin_tx['advanced_search']['quotechar']=chr(251); //temporary = some unused char in your language


$phonetic_search=eregi("true",$plugin_cf['advanced_search']['phonetic_search']);
$search = preg_replace('/[\s]+/',' ',$search); 
$search = preg_replace('/[\s]*[\+][\s]*/i', ' +',$search); //remove extra spaces
$search = stripslashes(trim(preg_replace('/[\s]*[\-][ \s]*/i', ' -',$search))); //remove extra spaces
//$search=preg_replace('/"(.*)[\s](.*)"/','+$1 +$2', $search); //convert "a b" to +a +b can't do it with "a b c"

$soundex_search="";
$page_data=null;

if ($search != '') {
	adv_search($search,$hits,$likes,$soundex_search,"");
	// 2lang search
	if (($l!=$plugin_cf['advanced_search']['search_2lang']) && (strlen($plugin_cf['advanced_search']['search_2lang'])==2) && is_dir('./'.$plugin_cf['advanced_search']['search_2lang'])) {
		advs_rfc($plugin_cf['advanced_search']['search_2lang']);
		if (isset($pd_router)) {   
			//page_param plugin stores the path to pagedata.php in the constant why it is nor possible to reload page_param for 2lang. 
			unset($pd_router); // destroy - page_param functionality is not avalialble in 2lang
  	}
  	include('./'.$plugin_cf['advanced_search']['search_2lang'].'/content/pagedata.php');
		adv_search($search,$hits,$likes,$soundex_search,$plugin_cf['advanced_search']['search_2lang']);
		rfc(); // reload original content
	}	
	adv_search_log($search,$hits,$likes, $soundex_search);
}
$o.=adv_search_output($search, $hits,$likes);

function adv_search($search, &$hits, &$likes, &$soundex_search, $scd_lang) 
{
	global $cl, $c, $h, $l, $cf, $plugin_cf, $plugin_tx, $tx, $phonetic_search, $pd_router, $page_data; 
	
	$scd_lang_alias = (trim($scd_lang)!="")?" (".$plugin_cf['advanced_search']['search_2lang_alias'].")": "";
  for($i = 0; $i < $cl; $i++) { // fo every CMSimple page
  	$page_visible=true;
		if (isset($pd_router)) {
			$page = $pd_router -> find_page($i);
			$page_visible = ($page['linked_to_menu']!='0') && ($page['published'] != '0');
			if ($page[show_heading]=="1") {
    		$c[$i] = str_replace($h[$i], $page[heading] , $c[$i]); //replace heading with the one stored in $pd_router
			}
		}
		if (isset($page_data)) {
			$page_visible = ($page_data[$i]['linked_to_menu']!='0') && ($page_data[$i]['published']!='0');
			if ($page_data[$i]['show_heading']=="1") {
    		$c[$i] = str_replace($h[$i], $page_data[$i]['heading'] , $c[$i]); //replace heading with the one stored in $pd_router
			}
		}
    if (!hide($i) && $page_visible ) { //exept of hiden pages
    	
    	$content=get_plugin($c[$i],$cf['scripting']['regexp'], $plugin_cf['advanced_search']['plugin_search']); //get content of CMSimple scripts
    	$content.=preg_replace('/'.$cf['scripting']['regexp'].'/i',' ',$c[$i]); //add content and remove cmsimple scipts using regexp definition from config.php
    	$content.=get_pd_scripting($i,$cf['scripting']['regexp'],$plugin_cf['advanced_search']['plugin_search']); //get content from pd_scripting
    	$content=preg_replace('/<[^>]*>/',' ',(function_exists('html_entity_decode')? html_entity_decode( mb_strtolower($content, $tx['meta']['codepage']), ENT_QUOTES, $tx['meta']['codepage']): mb_strtolower($content, $tx['meta']['codepage'])));  //remove html tags and convert to lower case
    	//$content=preg_replace('/<[^>]*>/',' ',$content);  //remove html tags
	    $tok = strtok(quotes($search,$plugin_tx['advanced_search']['quotechar']), " "); //split spaces
	    $sarg="";
			$found=false;
	    while ($tok != false) {
	      if ($tok=="+" || $tok=="-") {
	        $sarg = $tok;   //the space between search argument and keyword detected
	      }
				else {
	      	if ($tok[0]=="+" || $tok[0]=="-"){   //catch argument if any
						$sarg=$tok[0];
						$tok=substr($tok,1);
					}
	    					
					$tok=preg_replace('['.$plugin_tx['advanced_search']['quotechar'].']',' ', $tok); // quote replace to spaces
					if (@preg_match('/'.preg_quote( mb_strtolower($tok, $tx['meta']['codepage']), '/').'/i', $content))	{		//search for tok on the page		
//					if (@preg_match('/'.preg_quote($tok, '/').'/i', $content)) {
					 	if ($sarg=="-") {
					 	 	$found=false;
						 	break;
						}
						else {
						 	$found=true;
				 		}
					}
					else 
						if ($sarg=="+") {
						 	$found=false;
							break;
						}
					if (!$found && $sarg!="-" && $phonetic_search) {
						$stmp = get_soundex($tok,$content,$plugin_cf['advanced_search']['phonetic_search_type']); 
		    		if (strlen($stmp)>2) {
	 	   				$soundex_search .=$stmp." ";
							$likes[]='<a href="'. advs_path($scd_lang,$h,$l,$h[$i],$stmp).'">'.'('.$stmp.') '.$plugin_tx['advanced_search']['in'].' '.$h[$i].$scd_lang_alias.'</a>';
						}
					}
					$sarg="";
	   		}
	      $tok = strtok(" ");
	    }
		  if ($found) {
 				$hits[]='<a href="'. advs_path($scd_lang,$h,$l,$h[$i],$search).'">'.$h[$i].$scd_lang_alias.'</a>';
	    }
 		}
	}
	return;
}

function advs_path($scd_lang, $h, $l, $page, $keyword)
{ 	
	global $plugin_cf;
	
 	$pagearray=array();
	$count=0;
	$tmp="";
	$keyword = preg_replace('/[-\+]/i', '',$keyword);
	$scd_lang=($scd_lang!="")?$scd_lang."/":$scd_lang;
  foreach ($h as $i) {
  	$pagearray[$l[$count]]=$h[$count];
		if ($i==$page) {
			for($n=1; $n<$l[$count]; $n++) {
				$tmp.=urlencode(preg_replace('/ /','_',$pagearray[$n])).":";
			}
			if (eregi("true", $plugin_cf['advanced_search']['highlight'])) {
				$keyword=amp().'q='.strtolower(quotes($keyword,'+'));
			}
			else {
				$keyword="";
			}					
			return $scd_lang."?".$tmp.urlencode(preg_replace('/ /','_',$page)).$keyword;
		}    
    ++$count;
  }
}

function get_soundex($input,$text,$search_type)
{ 
	global $pth;
	
  $inplen=sizeof(preg_split('/[\s]/',$input));
  $words= preg_split('/[\s.,:;]/i', $text,-1,PREG_SPLIT_NO_EMPTY); 
 
  if (eregi("doublemetaphone",$search_type)) {
    if(!@(include_once($pth['folder']['base'].'plugins/advanced_search/data/doublemetaphone.php')))
      die ('<b>      doublemetaphone.php not found!</b>');
		$mp=double_metaphone($input); 
		for ($i=0;$i<sizeof($words)-$inplen+1;$i++) {
    	$w="";
      for ($j=0;$j<$inplen;$j++) $w.=$words[$i+$j].' ';
      $w=preg_replace("/<.*>/","",trim($w)); //remove html tags
      $wmp = double_metaphone($w); 
      if ($mp["primary"]==$wmp["primary"] || ($mp["secondary"]!=null && $mp["secondary"]==$wmp["secondary"])) {
        return $w;
      }
    }
  }   
  if (eregi("metaphone",$search_type)) {
    $sw=metaphone($input);
    for ($i=0;$i<sizeof($words)-$inplen+1;$i++) {
      $w="";
      for ($j=0;$j<$inplen;$j++) $w.=$words[$i+$j].' ';
      $w=preg_replace("/<.*>/","",trim($w)); //remove html tags
   	  $lev=levenshtein(strtolower($input), strtolower($w));
      if ((levenshtein($sw, metaphone($w))<=2) && ($lev>0 && intval(($lev/strlen($w))*100)<=30)) { 
  	  return $w;
      }
    }
  }
  if (eregi("soundex",$search_type)) {
    $sw=soundex($input);
    for ($i=0;$i<sizeof($words);$i++) {
      $w="";
      for ($j=0;$j<$inplen;$j++) $w.=$words[$i+$j].' ';
      $w=preg_replace("/<.*>/","",trim($w)); //remove html tags
	    $lev=levenshtein(strtolower($input), strtolower($w));
      if (strcmp($sw,soundex($w))==0 || ($lev>0 && intval(($lev/strlen($w))*100)<=20)) { //max 10%
    	  return $w;
      }
    }           
  }
  return "";
}

function get_pd_scripting($count, $script,$pluginsearch){
	global $plugin_cf, $pd_router;
	
	if (eregi("false", $pluginsearch)) 
  	return "";
	$plg="";  	
	if (isset($pd_router) && isset($plugin_cf['hi_pd_scripting']['scripts_max_on_page'])) { //if page_param and hi_pd_scripting is activated then search through pageparam.php
		$page_pd = $pd_router -> find_page($count); // get page
		// search for advanced search in hi_pd_scripting fields in pageparam
		for ($pd_i = 1; ($pd_i <= $plugin_cf['hi_pd_scripting']['scripts_max_on_page']); $pd_i++) {
			if ($page_pd['hi_pd_scripting_active'.$pd_i] == '1') {  // activated
				$pd_tmp="\$output.=".$page_pd['hi_pd_scripting_code'.$pd_i];
				if (eregi("true", $pluginsearch)) {
					@eval($pd_tmp);
					$plg.=$output;
				}
				else {
					$arr=split("[:,;]",$pluginsearch);
					for ($i=0; $i<sizeof($arr);$i++) {
			 			if (eregi(trim($arr[$i]),$pd_tmp)) {
			 				@eval($pd_tmp);
							$plg.=$output;
		 				}
					}
				}
			}	
		}
		return $plg;
	}
	return "";
}

function get_plugin($page, $script,$pluginsearch)
{
	$plg="";
  if (eregi("false", $pluginsearch)) 
  	return $plg;
	$t = preg_replace("/^.*" . $script . ".*$/is", "\\1", $page);  // get cmsimple script  	
	if (eregi("true", $pluginsearch)) {  //search all plugins
	  if ($t != '' && $t != $page && $t != 'remove') {
//	  	$plg = preg_replace("/" . $script . "/is", "", $page);
		  if (!stristr($t, 'header(')) 
				@eval(preg_replace(array("'&(quot|#34);'i", "'&(amp|#38);'i", "'&(apos|#39);'i", "'&(lt|#60);'i", "'&(gt|#62);'i", "'&(nbsp|#160);'i"), array("\"", "&", "'", "<", ">", " "), $t));
    		return $output;
  	} 
  }	
  else {  // search specified plugins
		$arr=split("[:,;]",$pluginsearch);
		$t = preg_replace("/^.*" . $script . ".*$/is", "\\1", $page);  // get cmsimple script
		for ($i=0; $i<sizeof($arr);$i++) {
		 if (eregi(trim($arr[$i]),$t)) {			 	
			if ($t != '' && $t != $page && $t != 'remove') { 
			  if (!stristr($t, 'header(')) 
					@eval(preg_replace(array("'&(quot|#34);'i", "'&(amp|#38);'i", "'&(apos|#39);'i", "'&(lt|#60);'i", "'&(gt|#62);'i", "'&(nbsp|#160);'i"), array("\"", "&", "'", "<", ">", " "), $t));		  
		   		$plg.=$output;
 			 	} 
			}		
		}
		return $plg;
	}
 	return "";
}

function adv_search_output($search, $hits,$likes)  
{
	global $plugin_cf, $plugin_tx, $tx,$soundex_search; 
	if ($search != '') {
		$o.=local_searchbox($plugin_cf['advanced_search']['advsearchbox_size'],$search);
	  $o .= '<h1>'.$tx['search']['result'].'</h1><p>"'.htmlspecialchars(stripslashes($search)).'" ';
	  if (count($hits) == 0)
	    $o .= $tx['search']['notfound'].'.</p>';
	  else {
	  	$o .= $tx['search']['foundin'].' '.count($hits). ' ';
		   if (count($hits) > 1) $o.=$tx['search']['pgplural'];
	    else $o.=$tx['search']['pgsingular'];
	  	$search = preg_replace('/[-\+]/i', '',$search);
	  	$o .= ':</p>'.li_search($hits,$search);
	  }
	  if (count($likes) > 0) {
	    $o.=$plugin_tx['advanced_search']['phonetic_search_text_1'];
	    $o.=(count($likes) > 1)? $tx['search']['pgplural']:$tx['search']['pgsingular'];
	    $o.=$plugin_tx['advanced_search']['phonetic_search_text_2'];
	  	$o.=li_search($likes,trim($soundex_search));
	  }

	}
	else 
  	$o.=local_searchbox($plugin_cf['advanced_search']['advsearchbox_size'],$search);
  // DO NOT REMOVE. If you have purchased a license change class author in stylesheet.css to display: none;
	$o.=tag('br').'<p class="author">CMSimple plugin: AdvancedSearch<a href="http://cmsimpleplugins.jakobsfeld.dk/?Advanced_Search"></a>'.tag('br').'v.2 &copy; Jerry Jakobsfeld</p>';
		// DO NOT REMOVE	
	return $o;
}

function adv_search_log($search,$hits,$likes,$soundex_search) 
{
	global $plugin, $plugin_cf, $pth, $phonetic_search;
	
  if ($plugin_cf['advanced_search']['log']=="true") {
	  $fileName = $pth['folder']['plugins']."advanced_search/search_log.txt";
		$fh  = fopen($fileName, 'a') or die("can't open file");
		$logline= "Search string=[".$search."] hits=".count($hits);
	
		if ($phonetic_search)
			$logline.=" Soundex search: hits=".count($likes)." word: [".$soundex_search."]";
		$logline.=" date=".date('d-m-y H:i')."\n";
		fwrite($fh, $logline);
		fclose($fh);
	}
	return;
}

function quotes($st,$ch) {
  $quote=0;
  for ($i=0;$i<strlen($st);$i++) {
    if ($st[$i]=='"') 
      ++$quote;
    else if (($quote%2)==1 && $st[$i]==" ") 
      $st[$i]=$ch;
  }
  return preg_replace('["]','',$st);
}

function li_search($hits,$search) {
	global $s, $l, $h, $cl, $cf, $u;

	$tl = count($hits);
	if ($tl < 1)return;
	$t = '';
	$t .= '<ul class="'.$st.'">';
	for($i = 0; $i < count($hits); $i++) {
		$t .= '<li class="doc">'.$hits[$i].'</li>';
	}
	$t .= '</ul>';
	return $t;
}

function local_searchbox($size,$search) {
	global $sn, $tx, $hjs, $plugin_cf, $pth;
	
	$soundex_select="";
	//$soundex_select = '<Input type="Checkbox" Name ="soundex" value ="ch" '.$checked.'>'.$plugin_tx['advanced_search']['phonetic_search'].$phonetic_search.'>';
	$t= tag('br');
	$t.='<form action="'.$sn.'" method="post">';
	$t.='<div id="advsearchbox">';
	$t.=tag('input type="text" value="'.htmlspecialchars(stripslashes($search)).'" class="text" name="search" onfocus="showtxt(\'helptxt\',\'short\');" size="'.$size.'"');
	$t.=tag('input type="hidden" name="function" value="search"');
	$t.='&nbsp;'.tag('input type="image" src="'.$pth['folder']['base'].$plugin_cf['advanced_search']['submit_icon'].'"  value="'.$tx['search']['button'].'"  alt="'.$tx['search']['button'].'"  name="submit"  title="'.$tx['search']['button'].'"');
	$t.='<span style="cursor:help" onmouseout="showtxt(\'helptxt\',\'short\');" onmouseover="showtxt(\'helptxt\',\'long\');">&nbsp;&nbsp;&nbsp;';
	$t.=tag('img src="'.$pth['folder']['base'].$plugin_cf['advanced_search']['help_icon'].'" width="18" height="18" alt="'.$tx['search']['button'].'"');
	$t.='&nbsp;'.tag('br').'</span>'.$soundex_select.'</div></form><div id="helptxt"></div>';
	return $t; 
}

function advs_rfc($sl){
    global $c, $cl, $h, $u, $l, $su, $s, $pth, $tx, $edit, $adm, $cf;

    $c = array();
    $h = array();
    $u = array();
    $l = array();
    $empty = 0;
    $duplicate = 0;

    $content = file_get_contents('./'.$sl.'/'.$pth['file']['content']);
    $stop = $cf['menu']['levels'];
    $pattern = '/(<h([1-'.$stop.'])[^>]*>(.*)<\/h[1-'.$stop.'](.+))(?=(<(h[1-'.$stop.']|\/body).*>))/isU';
    preg_match_all($pattern, $content, $pages);

    $c = $pages[1];
    $cl = count($c);
    $s = -1;

    if ($cl == 0){
        $c[] = '<h1>'.$tx['toc']['newpage'].'</h1>';
        $h[] = trim(strip_tags($tx['toc']['newpage']));
        $u[] = uenc($h[0]);
        $l[] = 1;
        $s = 0;
        return;
    }

    $l = $pages[2];
    $ancestors = array();  /* just a helper for the "url" construction:
                        * will be filled like this [0] => "Page"
                        *                          [1] => "Subpage"
                        *                          [2] => "Sub_Subpage" etc.
                        */

    foreach($pages[3] as $i => $heading){
        $temp = trim(strip_tags($heading));
        if($temp == ''){
            $empty++;
            $temp = $tx['toc']['empty']. ' '. $empty;
        }
        $h[] = $temp;
        $ancestors[$l[$i]-1] = uenc($temp);
        $ancestors = array_slice($ancestors,0, $l[$i]);
        $url = implode($cf['uri']['seperator'], $ancestors);
        $u[] = substr($url, 0, $cf['uri']['length']);
    }

    foreach($u as $i => $url){
        if ($su == $u[$i]){$s = $i;} // get index of selected page

        for($j = $i + 1; $j < $cl; $j++){   //check for duplicate "urls"
            if($u[$j] == $u[$i]){
                $duplicate++;
                $h[$j] = $tx['toc']['dupl'].' '.$duplicate;
                $u[$j] = uenc($h[$j]);
            }
        }
    }
    if(!($edit && $adm)){
        foreach($c as $i => $j) {
            if (cmscript('remove', $j)){$c[$i] = '#CMSimple hide#';}
        }
    }
}
?>