<?php
/*
============================================================
    AdvancedSearch for CMSimple
============================================================
    Version:    2.0 released october 2010
    Copyright:   Jerry Jakobsfeld
    Website:    http://cmsimpleplugins.jakobsfeld.dk

    Change summary
  Version:    1.1.0 released september 2008
    version 1.0.1 29.09.2008 include of searchhi.js removed from function advanced_search and made global. No need to intialise in template.htm.
    version 1.0.2 17.10.2009 onload in searchhi.js replaced with addLoadEvent function for compability with other plugins using onload.
    version 1.1  (okt. 2008)
added Double Metaphone search as default. Double Metaphone tries to account for myriad irregularities in English and Slavic, Germanic, Celtic, Greek, French, Italian, Spanish, Chinese, and other origin. Thus it uses a much more complex ruleset for coding than metaphone; for example, it tests for approximately 100 different contexts of the use of the letter C alone.

		version 1.2
Fixed bug - html tags removed from search result of plugin search
Search result of phonetic search shorter then 3 char are ignored.
Added function advsearchbox() with optional icon facility instead of submit button - replaces cmsimple call to searchbox(). Added configuration option "hide searchbox" to avoid 2 searchboxes on search result page.
version 1.3
added support for multilanguages (2lang)
version 1.4
ensured compatibility with hi_pd_scripting plugin
version 1.5
ensured compatibility with CMSimple_XH version 1.2 onload
Optimized code for pd_hd_scripting plugin
search in 2lang content
Version 1.6.0
Rewrited search functionality for compatilbility with utf-8 and ANSII encoded pages
Added Search in 2lang directory (multilanguage sites).
Code optimzation
Version 2.0 Released under remove link and Commercial license
  ============================================================
The idea how to make advanced search to a plugin comes from Tillman Schusters plugin highlight_search 
*/
global $plugin, $hjs, $pth;
$hjs.='<script src="'.$pth['folder']['base'].'plugins/advanced_search/searchhi.js" type="text/javascript"></script>';
$onload.='googleSearchHighlight();';

$plugin = basename(dirname(__file__), "/");

function advanced_search()
{
// dummy - only compability with earler versions.	 
} 

function advsearchbox() {
	global $sn, $tx, $plugin_cf, $pth;
	
return '<form action="'.$sn.'" method="post"><div id="searchbox">'.tag('input type="text" class="text" name="search" size="21" focus(); ').tag('input type="hidden" name="function" value="search"').' '.tag('input type="image" src="'.$pth['folder']['base'].$plugin_cf['advanced_search']['submit_icon'].'" style="cursor:hand" value="'.$tx['search']['button'].'"  alt="[Submit]"  name="submit"  title="'.$tx['search']['button'].'"').'</div></form>';
}
?>